<?php
/*
** $Id: md.php,v 1.2 2017/06/21 18:31:19 burke Exp $
** 
** Copyright (c) 2017 Mattias Wikstrom <burke@yagrebu.net>
** This is free software as defined by the Free Software Foundation.
** See the separate LICENSE file for further details.
*/

/*
** Uncomment the line below to set a stylesheet. 
*/
//$stylesheet = ".md.css";

/*
** Make sure the path to the Parsedown library is correct. 
*/
require ".Parsedown.php";

/*
** Check the input file and make it available as $file. 
*/
if(isset($_GET["file"])) {
	$request = trim($_GET["file"], "./");

	if(preg_match("/(\.md|\.markdown)$/", $request)) {
		if(file_exists($request)) {
			$file = $request;
		} else {
			die("error: file not found.");
		}
	} else {
		die("error: markdown expected.");
	}

} else {
	die("error: variable not set.");
}

/*
** Get the text and parse the Markdown to html. 
*/
$text = file_get_contents($file);
$html = Parsedown::instance()->text($text);

/*
** Figure out a title for the html document. 
*/
if(preg_match("/\<h1\>.+\<\/h1\>/", $html, $match)) {
	$title = strip_tags($match[0]);
} else {
	$title = "Untitled";
}

/*
** Replace <a href="man">ls(1)</a> with link to man.freebsd.org. 
*/
$pattern = '/\<a href="man"(.*)\>(([^<>\s]+)\(([0-9])\))\<\/a\>/';
$replace = '<a href="https://man.freebsd.org/$3/$4"$1>$2</a>';

$html = preg_replace($pattern, $replace, $html);

/*
** Here follows the template for the html document...
*/
?>
<!DOCTYPE html>
<html>
	<head>
		<meta charset="UTF-8">
		<title><?php echo $title; ?></title>
		<?php
			if(isset($stylesheet)) { 
				echo "<link href=\"$stylesheet\" rel=\"stylesheet\">\n";
			}
		?>
	</head>
	<body>
		<?php echo $html; ?>
	</body>
</html>
